/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2206 from the
 * contents of Twofish2.xs. Do not edit this file, edit Twofish2.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Twofish2.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* try to be compatible with older perls */
/* SvPV_nolen() macro first defined in 5.005_55 */
/* this is slow, not threadsafe, but works */
#include "patchlevel.h"
#if (PATCHLEVEL == 4) || ((PATCHLEVEL == 5) && (SUBVERSION < 55))
static STRLEN nolen_na;
# define SvPV_nolen(sv) SvPV ((sv), nolen_na)
#endif

#include "aes.h"
#include "twofish.c"

typedef struct cryptstate {
  keyInstance ki;
  cipherInstance ci;
} *Crypt__Twofish2;

#line 32 "Twofish2.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 84 "Twofish2.c"

XS(XS_Crypt__Twofish2_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__Twofish2_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "class, key, mode=MODE_ECB");
    {
	SV *	class = ST(0);
	SV *	key = ST(1);
	int	mode;
	Crypt__Twofish2	RETVAL;

	if (items < 3)
	    mode = MODE_ECB;
	else {
	    mode = (int)SvIV(ST(2));
	}
#line 43 "Twofish2.xs"
        {
          STRLEN keysize;

          if (!SvPOK (key))
            croak ("key must be a string scalar");

          keysize = SvCUR(key);

          if (keysize != 16 && keysize != 24 && keysize != 32)
            croak ("wrong key length: key must be 128, 192 or 256 bits long");
          if (mode != MODE_ECB && mode != MODE_CBC && mode != MODE_CFB1)
            croak ("illegal mode: mode must be MODE_ECB, MODE_2 or MODE_CFB1");

          Newz (0, RETVAL, 1, struct cryptstate); /* Newz required for defined IV */

          if (makeKey (&RETVAL->ki, DIR_ENCRYPT, keysize*8, SvPV_nolen(key)) != TRUE)
            croak ("Crypt::Twofish2: makeKey failed, please report!");
          if (cipherInit (&RETVAL->ci, mode, 0) != TRUE) /* no IV supported (yet) */
            croak ("Crypt::Twofish2: makeKey failed, please report!");
        }         
#line 128 "Twofish2.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::Twofish2", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__Twofish2_encrypt); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__Twofish2_encrypt)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	Crypt__Twofish2	self;
	SV *	data = ST(1);
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Twofish2")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Twofish2,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"self", "Crypt::Twofish2");
#line 73 "Twofish2.xs"
        {
          SV *res;
          STRLEN size;
          void *rawbytes = SvPV(data,size);

          if (size)
            {
              if (size % (BLOCK_SIZE >> 3))
                croak ("encrypt: datasize not multiple of blocksize (%d bits)", BLOCK_SIZE);

              RETVAL = NEWSV (0, size);
              SvPOK_only (RETVAL);
              (SvPVX (RETVAL))[size] = 0;
              SvCUR_set (RETVAL, size);

              if ((ix ? blockDecrypt : blockEncrypt)
                    (&self->ci, &self->ki, rawbytes, size << 3, (void *)SvPV_nolen(RETVAL)) < 0)
                croak ("block(De|En)crypt: unknown error, please report");
            }
          else
            RETVAL = newSVpv ("", 0);
        }
#line 183 "Twofish2.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__Twofish2_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__Twofish2_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Twofish2	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Twofish2,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Crypt::Twofish2::DESTROY",
			"self");
#line 102 "Twofish2.xs"
        Safefree(self);
#line 214 "Twofish2.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Crypt__Twofish2); /* prototype to pass -Wmissing-prototypes */
XS(boot_Crypt__Twofish2)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        (void)newXSproto_portable("Crypt::Twofish2::new", XS_Crypt__Twofish2_new, file, "$$;$");
        cv = newXSproto_portable("Crypt::Twofish2::decrypt", XS_Crypt__Twofish2_encrypt, file, "$$");
        XSANY.any_i32 = 1 ;
        cv = newXSproto_portable("Crypt::Twofish2::encrypt", XS_Crypt__Twofish2_encrypt, file, "$$");
        XSANY.any_i32 = 0 ;
        (void)newXSproto_portable("Crypt::Twofish2::DESTROY", XS_Crypt__Twofish2_DESTROY, file, "$");
    }

    /* Initialisation Section */

#line 27 "Twofish2.xs"
{
	HV *stash = gv_stashpv ("Crypt::Twofish2", 0);

	newCONSTSUB (stash, "keysize",   newSViv (32));
	newCONSTSUB (stash, "blocksize", newSViv (16));
	newCONSTSUB (stash, "MODE_ECB",  newSViv (MODE_ECB));
	newCONSTSUB (stash, "MODE_CBC",  newSViv (MODE_CBC));
	newCONSTSUB (stash, "MODE_CFB1", newSViv (MODE_CFB1));
}

#line 264 "Twofish2.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

